【HDU】4745Two Rabbits-最长回文子序列

                   Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
                                         Total Submission(s): 2418    Accepted Submission(s): 1251


 

Problem Description

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai.

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise.

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise.

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn't jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone.

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time.

Now they want to find out the maximum turns they can play if they follow the optimal strategy.

 

 

Input

The input contains at most 20 test cases.
For each test cases, the first line contains a integer n denoting the number of stones.
The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000)
The input ends with n = 0.

 

 

Output

For each test case, print a integer denoting the maximum turns.

 

 

Sample Input

 

1 1 4 1 1 2 1 6 2 1 1 2 1 3 0

 

 

Sample Output

 
1 4 5

Hint

For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2. For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.

 

 

Source

2013 ACM/ICPC Asia Regional Hangzhou Online

 

 

Recommend

liuyiding   |   We have carefully selected several similar problems for you:  6408 6407 6406 6405 6404 

 

 

题目大意:两个兔子,有n个石头围成环形,每个石头都有一个权值ai,他们只能相反方向跳,每跳一次,他们脚下的石头权值必须相同,问跳几次调到一个石头上,

思路:

    可以看出,题目求一个环的最长回文子序列,一个环的话,就可以弄成2*n的链求出最长的子序列,但这还不是最终的解,

    因为它在选中的回文外面还可以选中一个当做起点来跳,所以外面得判断找出来的回文外面是否还有可以当起点的石头,

    即可以找窗口为(n-1)的长度+1。所以解即找 窗口为n的长度或者 窗口为(n-1)的长度+1 的最大值

阶段:枚举长度

状态:枚举起点

决策:两种判断,看头和尾是否相同,以及求各个子区间的最大值

状态转移方程:dp[i][j]=max(dp[i+1][j],max(dp[i][j],dp[i][j-1]));

 代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<string>
#define maxn 2555
using namespace std;

int dp[maxn][maxn];
int a[maxn];
int n;
int main()
{
    while(scanf("%d", &n) && n)
    {
        for(int i=1; i<=n; i++)
        {
            cin>>a[i];
            a[i+n]=a[i];
        }

        memset(dp,0,sizeof(dp));
        for(int i=1; i<=2*n; i++)
            dp[i][i]=1;
        for(int len=1; len<2*n; len++)
            for(int i=1; i+len<=2*n; i++)
            {
                int j=len+i;
                if(a[i]==a[j])
                {
                    dp[i][j]=dp[i+1][j-1]+2;
                }
                dp[i][j]=max(dp[i+1][j],max(dp[i][j],dp[i][j-1]));
            }
        int ans=0;
        for (int i = 1; i <= n; i++)
			ans = max(ans, dp[i][i + n - 1]);
		for (int i = 1; i <= n; i++)
			ans = max(ans, dp[i][i + n - 2] + 1);
		printf("%d\n", ans);
    }
}

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值